diff -ruN vdr-1.7.24/dvbdevice.c vdr-1.7.25/dvbdevice.c
--- vdr-1.7.24/dvbdevice.c	2012-02-17 13:20:34.000000000 +0100
+++ vdr-1.7.25/dvbdevice.c	2012-02-29 13:23:43.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 2.62 2012/02/17 12:20:34 kls Exp $
+ * $Id: dvbdevice.c 2.65 2012/02/29 12:23:43 kls Exp $
  */
 
 #include "dvbdevice.h"
@@ -420,7 +420,7 @@
   if (cDvbTuner *t = bondedTuner) {
      cString BondingParams = GetBondingParams(Channel);
      do {
-        if (t->device->Receiving() || t->tunerStatus != tsIdle && (t->device == cDevice::ActualDevice() || ConsiderOccupied && t->device->Occupied())) {
+        if (t->device->Receiving() || ConsiderOccupied && t->device->Occupied()) {
            if (strcmp(BondingParams, t->GetBondingParams()) != 0)
               return false;
            }
@@ -1437,14 +1437,14 @@
 bool cDvbDevice::ProvidesChannel(const cChannel *Channel, int Priority, bool *NeedsDetachReceivers) const
 {
   bool result = false;
-  bool hasPriority = Priority < 0 || Priority > this->Priority();
+  bool hasPriority = Priority == IDLEPRIORITY || Priority > this->Priority();
   bool needsDetachReceivers = false;
   needsDetachBondedReceivers = false;
 
   if (dvbTuner && ProvidesTransponder(Channel)) {
      result = hasPriority;
      if (Priority >= 0) {
-        if (Receiving(true)) {
+        if (Receiving()) {
            if (dvbTuner->IsTunedTo(Channel)) {
               if (Channel->Vpid() && !HasPid(Channel->Vpid()) || Channel->Apid(0) && !HasPid(Channel->Apid(0))) {
                  if (CamSlot() && Channel->Ca() >= CA_ENCRYPTED_MIN) {
@@ -1453,16 +1453,14 @@
                     else
                        needsDetachReceivers = true;
                     }
-                 else if (!IsPrimaryDevice())
-                    result = true;
                  else
-                    result = Priority >= Setup.PrimaryLimit;
+                    result = true;
                  }
               else
-                 result = !IsPrimaryDevice() || Priority >= Setup.PrimaryLimit;
+                 result = true;
               }
            else
-              needsDetachReceivers = Receiving(true);
+              needsDetachReceivers = Receiving();
            }
         if (result) {
            if (!BondingOk(Channel)) {
@@ -1474,7 +1472,7 @@
                      }
                   }
               needsDetachBondedReceivers = true;
-              needsDetachReceivers = Receiving(true);
+              needsDetachReceivers = Receiving();
               }
            }
         }
@@ -1591,21 +1589,43 @@
 
 uint32_t cDvbDeviceProbe::GetSubsystemId(int Adapter, int Frontend)
 {
-  cString FileName;
-  cReadLine ReadLine;
-  FILE *f = NULL;
   uint32_t SubsystemId = 0;
-  FileName = cString::sprintf("/sys/class/dvb/dvb%d.frontend%d/device/subsystem_vendor", Adapter, Frontend);
-  if ((f = fopen(FileName, "r")) != NULL) {
-     if (char *s = ReadLine.Read(f))
-        SubsystemId = strtoul(s, NULL, 0) << 16;
-     fclose(f);
-     }
-  FileName = cString::sprintf("/sys/class/dvb/dvb%d.frontend%d/device/subsystem_device", Adapter, Frontend);
-  if ((f = fopen(FileName, "r")) != NULL) {
-     if (char *s = ReadLine.Read(f))
-        SubsystemId |= strtoul(s, NULL, 0);
-     fclose(f);
+  cString FileName = cString::sprintf("/dev/dvb/adapter%d/frontend%d", Adapter, Frontend);
+  struct stat st;
+  if (stat(FileName, &st) == 0) {
+     cReadDir d("/sys/class/dvb");
+     if (d.Ok()) {
+        struct dirent *e;
+        while ((e = d.Next()) != NULL) {
+              if (strstr(e->d_name, "frontend")) {
+                 FileName = cString::sprintf("/sys/class/dvb/%s/dev", e->d_name);
+                 if (FILE *f = fopen(FileName, "r")) {
+                    cReadLine ReadLine;
+                    char *s = ReadLine.Read(f);
+                    fclose(f);
+                    unsigned Major;
+                    unsigned Minor;
+                    if (s && 2 == sscanf(s, "%u:%u", &Major, &Minor)) {
+                       if (((Major << 8) | Minor) == st.st_rdev) {
+                          FileName = cString::sprintf("/sys/class/dvb/%s/device/subsystem_vendor", e->d_name);
+                          if ((f = fopen(FileName, "r")) != NULL) {
+                             if (char *s = ReadLine.Read(f))
+                                SubsystemId = strtoul(s, NULL, 0) << 16;
+                             fclose(f);
+                             }
+                          FileName = cString::sprintf("/sys/class/dvb/%s/device/subsystem_device", e->d_name);
+                          if ((f = fopen(FileName, "r")) != NULL) {
+                             if (char *s = ReadLine.Read(f))
+                                SubsystemId |= strtoul(s, NULL, 0);
+                             fclose(f);
+                             }
+                          break;
+                          }
+                       }
+                    }
+                 }
+              }
+        }
      }
   return SubsystemId;
 }
diff -ruN vdr-1.7.24/dvbdevice.h vdr-1.7.25/dvbdevice.h
--- vdr-1.7.24/dvbdevice.h	2012-02-17 12:18:55.000000000 +0100
+++ vdr-1.7.25/dvbdevice.h	2012-02-29 13:20:51.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.h 2.23 2012/02/17 11:18:55 kls Exp $
+ * $Id: dvbdevice.h 2.24 2012/02/29 12:20:51 kls Exp $
  */
 
 #ifndef __DVBDEVICE_H
@@ -179,7 +179,7 @@
   virtual bool ProvidesDeliverySystem(int DeliverySystem) const;
   virtual bool ProvidesSource(int Source) const;
   virtual bool ProvidesTransponder(const cChannel *Channel) const;
-  virtual bool ProvidesChannel(const cChannel *Channel, int Priority = -1, bool *NeedsDetachReceivers = NULL) const;
+  virtual bool ProvidesChannel(const cChannel *Channel, int Priority = IDLEPRIORITY, bool *NeedsDetachReceivers = NULL) const;
   virtual bool ProvidesEIT(void) const;
   virtual int NumProvidedSystems(void) const;
   virtual int SignalStrength(void) const;
diff -ruN vdr-1.7.24/dvbplayer.c vdr-1.7.25/dvbplayer.c
--- vdr-1.7.24/dvbplayer.c	2012-02-19 11:48:02.000000000 +0100
+++ vdr-1.7.25/dvbplayer.c	2012-02-21 12:34:04.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbplayer.c 2.23 2012/02/19 10:48:02 kls Exp $
+ * $Id: dvbplayer.c 2.25 2012/02/21 11:34:04 kls Exp $
  */
 
 #include "dvbplayer.h"
@@ -87,7 +87,6 @@
 private:
   cUnbufferedFile *f;
   uchar *buffer;
-  uchar *result;
   int wanted;
   int length;
   cCondWait newSet;
@@ -101,7 +100,7 @@
   void Clear(void);
   void Request(cUnbufferedFile *File, int Length);
   int Result(uchar **Buffer);
-  bool Reading(void) { return result; }
+  bool Reading(void) { return buffer; }
   bool WaitForDataMs(int msToWait);
   };
 
@@ -110,7 +109,6 @@
 {
   f = NULL;
   buffer = NULL;
-  result = NULL;
   wanted = length = 0;
   Start();
 }
@@ -120,7 +118,6 @@
   newSet.Signal();
   Cancel(3);
   free(buffer);
-  free(result);
 }
 
 void cNonBlockingFileReader::Clear(void)
@@ -129,8 +126,6 @@
   f = NULL;
   free(buffer);
   buffer = NULL;
-  free(result);
-  result = NULL;
   wanted = length = 0;
   Unlock();
 }
@@ -142,18 +137,18 @@
   wanted = Length;
   buffer = MALLOC(uchar, wanted);
   f = File;
-  newSet.Signal();
   Unlock();
+  newSet.Signal();
 }
 
 int cNonBlockingFileReader::Result(uchar **Buffer)
 {
   LOCK_THREAD;
-  if (result && length == wanted) {
-     *Buffer = result;
-     result = NULL;
+  if (buffer && length == wanted) {
+     *Buffer = buffer;
+     buffer = NULL;
      return wanted;
-  }
+     }
   errno = EAGAIN;
   return -1;
 }
@@ -177,8 +172,6 @@
               length = wanted = r; // this will forward the error status to the caller
               }
            if (length == wanted) {
-              result = buffer;
-              buffer = NULL;
               cMutexLock NewDataLock(&newDataMutex);
               newDataCond.Broadcast();
               }
@@ -190,9 +183,9 @@
 
 bool cNonBlockingFileReader::WaitForDataMs(int msToWait)
 {
-  if (result && length == wanted)
-     return true;
   cMutexLock NewDataLock(&newDataMutex);
+  if (buffer && length == wanted)
+     return true;
   return newDataCond.TimedWait(newDataMutex, msToWait);
 }
 
@@ -291,6 +284,8 @@
      delete index;
      index = NULL;
      }
+  else if (PauseLive)
+     framesPerSecond = cRecording(FileName).FramesPerSecond(); // the fps rate might have changed from the default
 }
 
 cDvbPlayer::~cDvbPlayer()
@@ -413,13 +408,13 @@
      Goto(0, true);
   while (Running()) {
         if (WaitingForData)
-           nonBlockingFileReader->WaitForDataMs(10); // this keeps the CPU load low, but reacts immediately on new data
+           nonBlockingFileReader->WaitForDataMs(3); // this keeps the CPU load low, but reacts immediately on new data
         else if (Sleep) {
            cPoller Poller;
            DevicePoll(Poller, 10);
            Sleep = false;
            if (playMode == pmStill || playMode == pmPause)
-              cCondWait::SleepMs(10);
+              cCondWait::SleepMs(3);
            }
         {
           LOCK_THREAD;
@@ -481,15 +476,7 @@
                    }
                 if (!eof) {
                    uchar *b = NULL;
-                   int Retries = 5;
-                   int r;
-                   while (true) {
-                         r = nonBlockingFileReader->Result(&b);
-                         if (r == -1 && errno == EAGAIN && --Retries)
-                            nonBlockingFileReader->WaitForDataMs(10); 
-                         else 
-                            break;
-                         }
+                   int r = nonBlockingFileReader->Result(&b);
                    if (r > 0) {
                       WaitingForData = false;
                       uint32_t Pts = 0;
diff -ruN vdr-1.7.24/dvbsubtitle.c vdr-1.7.25/dvbsubtitle.c
--- vdr-1.7.24/dvbsubtitle.c	2012-02-13 10:48:18.000000000 +0100
+++ vdr-1.7.25/dvbsubtitle.c	2012-03-02 11:47:25.000000000 +0100
@@ -7,7 +7,7 @@
  * Original author: Marco Schlüßler <marco@lordzodiac.de>
  * With some input from the "subtitle plugin" by Pekka Virtanen <pekka.virtanen@sci.fi>
  *
- * $Id: dvbsubtitle.c 2.22 2012/02/13 09:48:18 kls Exp $
+ * $Id: dvbsubtitle.c 2.27 2012/03/02 10:47:25 kls Exp $
  */
 
 
@@ -541,7 +541,6 @@
   void SetPts(int64_t Pts) { pts = Pts; }
   void SetState(int State);
   void SetTimeout(int Timeout) { timeout = Timeout; }
-  void UpdateRegionPalette(cSubtitleClut *Clut);
   };
 
 cDvbSubtitlePage::cDvbSubtitlePage(int PageId)
@@ -635,14 +634,6 @@
     }
 }
 
-void cDvbSubtitlePage::UpdateRegionPalette(cSubtitleClut *Clut)
-{
-  for (cSubtitleRegion *sr = regions.First(); sr; sr = regions.Next(sr)) {
-      if (sr->ClutId() == Clut->ClutId())
-         sr->Replace(*Clut->GetPalette(sr->Bpp()));
-      }
-}
-
 // --- cDvbSubtitleAssembler -------------------------------------------------
 
 class cDvbSubtitleAssembler {
@@ -806,7 +797,6 @@
   displayHeight = windowHeight = 576;
   windowHorizontalOffset = 0;
   windowVerticalOffset = 0;
-  SetOsdData();
   pages = new cList<cDvbSubtitlePage>;
   bitmaps = new cList<cDvbSubtitleBitmaps>;
   Start();
@@ -840,7 +830,6 @@
   displayHeight = windowHeight = 576;
   windowHorizontalOffset = 0;
   windowVerticalOffset = 0;
-  SetOsdData();
   Unlock();
 }
 
@@ -980,9 +969,9 @@
   Epb = (Cb - 128);
   Epr = (Cr - 128);
   /* ITU-R 709 */
-  Er = max(min(((298 * Ey             + 460 * Epr) / 256), 255), 0);
-  Eg = max(min(((298 * Ey -  55 * Epb - 137 * Epr) / 256), 255), 0);
-  Eb = max(min(((298 * Ey + 543 * Epb            ) / 256), 255), 0);
+  Er = constrain((298 * Ey             + 460 * Epr) / 256, 0, 255);
+  Eg = constrain((298 * Ey -  55 * Epb - 137 * Epr) / 256, 0, 255);
+  Eb = constrain((298 * Ey + 543 * Epb            ) / 256, 0, 255);
 
   return (Er << 16) | (Eg << 8) | Eb;
 }
@@ -995,7 +984,7 @@
   double VideoAspect;
   cDevice::PrimaryDevice()->GetOsdSize(OsdWidth, OsdHeight, OsdAspect);
   cDevice::PrimaryDevice()->GetVideoSize(VideoWidth, VideoHeight, VideoAspect);
-  if (OsdWidth == displayWidth && OsdHeight == displayHeight || DoubleEqual(VideoAspect, 1.0)) {
+  if (OsdWidth == displayWidth && OsdHeight == displayHeight) {
      osdFactorX = osdFactorY = 1.0;
      osdDeltaX = osdDeltaY = 0;
      }
@@ -1010,7 +999,11 @@
 bool cDvbSubtitleConverter::AssertOsd(void)
 {
   LOCK_THREAD;
-  return osd || (osd = cOsdProvider::NewOsd(int(round(osdFactorX * windowHorizontalOffset + osdDeltaX)), int(round(osdFactorY * windowVerticalOffset + osdDeltaY)) + Setup.SubtitleOffset, OSD_LEVEL_SUBTITLES));
+  if (!osd) {
+     SetOsdData();
+     osd = cOsdProvider::NewOsd(int(round(osdFactorX * windowHorizontalOffset + osdDeltaX)), int(round(osdFactorY * windowVerticalOffset + osdDeltaY)) + Setup.SubtitleOffset, OSD_LEVEL_SUBTITLES);
+     }
+  return osd != NULL;
 }
 
 int cDvbSubtitleConverter::ExtractSegment(const uchar *Data, int Length, int64_t Pts)
@@ -1035,7 +1028,7 @@
      if (!page) {
         page = new cDvbSubtitlePage(pageId);
         pages->Add(page);
-        dbgpages("Create SubtitlePage %d  (total pages = %d)\n", pageId, pages->Count());
+        dbgpages("Create SubtitlePage %d (total pages = %d)\n", pageId, pages->Count());
         }
      if (Pts)
         page->SetPts(Pts);
@@ -1112,7 +1105,7 @@
             }
        case CLUT_DEFINITION_SEGMENT: {
             dbgsegments("CLUT_DEFINITION_SEGMENT\n");
-            cSubtitleClut *clut =  page->GetClutById(bs.GetBits(8), true);
+            cSubtitleClut *clut = page->GetClutById(bs.GetBits(8), true);
             int clutVersion = bs.GetBits(4);
             if (clutVersion == clut->Version())
                break; // no update
@@ -1155,7 +1148,6 @@
                      clut->SetColor(8, clutEntryId, value);
                   }
             dbgcluts("\n");
-            page->UpdateRegionPalette(clut);
             break;
             }
        case OBJECT_DATA_SEGMENT: {
@@ -1310,7 +1302,11 @@
   cDvbSubtitleBitmaps *Bitmaps = new cDvbSubtitleBitmaps(Page->Pts(), Page->Timeout(), Areas, NumAreas, osdFactorX, osdFactorY);
   bitmaps->Add(Bitmaps);
   for (cSubtitleRegion *sr = Page->regions.First(); sr; sr = Page->regions.Next(sr)) {
-      sr->UpdateTextData(Page->GetClutById(sr->ClutId()));
+      cSubtitleClut *clut = Page->GetClutById(sr->ClutId());
+      if (!clut)
+         continue;
+      sr->Replace(*clut->GetPalette(sr->Bpp()));
+      sr->UpdateTextData(clut);
       int posX = sr->HorizontalAddress();
       int posY = sr->VerticalAddress();
       if (sr->Width() > 0 && sr->Height() > 0) {
diff -ruN vdr-1.7.24/eit.c vdr-1.7.25/eit.c
--- vdr-1.7.24/eit.c	2010-05-14 16:08:35.000000000 +0200
+++ vdr-1.7.25/eit.c	2012-02-25 16:25:51.000000000 +0100
@@ -8,7 +8,7 @@
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  * Adapted to 'libsi' for VDR 1.3.0 by Marcel Wiesweg <marcel.wiesweg@gmx.de>.
  *
- * $Id: eit.c 2.12 2010/05/14 14:08:35 kls Exp $
+ * $Id: eit.c 2.13 2012/02/25 15:25:51 kls Exp $
  */
 
 #include "eit.h"
@@ -38,6 +38,14 @@
      return; // only collect data for known channels
 
   cSchedule *pSchedule = (cSchedule *)Schedules->GetSchedule(channel, true);
+  if (pSchedule) {
+     if (cEvent *Event = pSchedule->Events()->First()) {
+        if (Event->TableID() == 0x00)
+           return; // never touch schedules with events from external sources
+        }
+     }
+  else
+     return;
 
   bool Empty = true;
   bool Modified = false;
diff -ruN vdr-1.7.24/epg.h vdr-1.7.25/epg.h
--- vdr-1.7.24/epg.h	2012-02-11 13:29:55.000000000 +0100
+++ vdr-1.7.25/epg.h	2012-02-26 14:58:26.000000000 +0100
@@ -7,7 +7,7 @@
  * Original version (as used in VDR before 1.3.0) written by
  * Robert Schneider <Robert.Schneider@web.de> and Rolf Hakenes <hakenes@hippomi.de>.
  *
- * $Id: epg.h 2.6 2012/02/11 12:29:55 kls Exp $
+ * $Id: epg.h 2.7 2012/02/26 13:58:26 kls Exp $
  */
 
 #ifndef __EPG_H
@@ -100,7 +100,7 @@
   const char *ShortText(void) const { return shortText; }
   const char *Description(void) const { return description; }
   const cComponents *Components(void) const { return components; }
-  uchar Contents(int i = 0) const { return (0 <= i && i < MaxEventContents) ? contents[i] : 0; }
+  uchar Contents(int i = 0) const { return (0 <= i && i < MaxEventContents) ? contents[i] : uchar(0); }
   int ParentalRating(void) const { return parentalRating; }
   time_t StartTime(void) const { return startTime; }
   time_t EndTime(void) const { return startTime + duration; }
diff -ruN vdr-1.7.24/font.c vdr-1.7.25/font.c
--- vdr-1.7.24/font.c	2012-01-13 10:43:22.000000000 +0100
+++ vdr-1.7.25/font.c	2012-03-02 11:47:45.000000000 +0100
@@ -6,7 +6,7 @@
  *
  * BiDi support by Osama Alrawab <alrawab@hotmail.com> @2008 Tripoli-Libya.
  *
- * $Id: font.c 2.9 2012/01/13 09:43:22 kls Exp $
+ * $Id: font.c 2.10 2012/03/02 10:47:45 kls Exp $
  */
 
 #include "font.h"
@@ -396,7 +396,7 @@
 
 void cFont::SetFont(eDvbFont Font, const char *Name, int CharHeight)
 {
-  cFont *f = CreateFont(Name, min(max(CharHeight, MINFONTSIZE), MAXFONTSIZE));
+  cFont *f = CreateFont(Name, constrain(CharHeight, MINFONTSIZE, MAXFONTSIZE));
   if (!f || !f->Height())
      f = new cDummyFont;
   delete fonts[Font];
diff -ruN vdr-1.7.24/libsi/section.h vdr-1.7.25/libsi/section.h
--- vdr-1.7.24/libsi/section.h	2006-04-14 12:53:44.000000000 +0200
+++ vdr-1.7.25/libsi/section.h	2012-02-26 14:58:26.000000000 +0100
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: section.h 2.0 2006/04/14 10:53:44 kls Exp $
+ *   $Id: section.h 2.1 2012/02/26 13:58:26 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -29,7 +29,7 @@
       int getServiceId() const;
       int getPid() const;
       bool isNITPid() const { return getServiceId()==0; }
-      virtual int getLength() { return sizeof(pat_prog); }
+      virtual int getLength() { return int(sizeof(pat_prog)); }
    protected:
       virtual void Parse();
    private:
@@ -61,7 +61,7 @@
       int getPid() const;
       int getStreamType() const;
       DescriptorLoop streamDescriptors;
-      virtual int getLength() { return sizeof(pmt_info)+streamDescriptors.getLength(); }
+      virtual int getLength() { return int(sizeof(pmt_info)+streamDescriptors.getLength()); }
    protected:
       virtual void Parse();
    private:
@@ -96,7 +96,7 @@
    public:
       int getTransportStreamId() const;
       int getOriginalNetworkId() const;
-      virtual int getLength() { return sizeof(ni_ts)+transportStreamDescriptors.getLength(); }
+      virtual int getLength() { return int(sizeof(ni_ts)+transportStreamDescriptors.getLength()); }
       DescriptorLoop transportStreamDescriptors;
    protected:
       virtual void Parse();
@@ -131,7 +131,7 @@
       int getEITpresentFollowingFlag() const;
       RunningStatus getRunningStatus() const;
       int getFreeCaMode() const;
-      virtual int getLength() { return sizeof(sdt_descr)+serviceDescriptors.getLength(); }
+      virtual int getLength() { return int(sizeof(sdt_descr)+serviceDescriptors.getLength()); }
       DescriptorLoop serviceDescriptors;
    protected:
       virtual void Parse();
@@ -168,7 +168,7 @@
       int getFreeCaMode() const;
 
       DescriptorLoop eventDescriptors;
-      virtual int getLength() { return sizeof(eit_event)+eventDescriptors.getLength(); }
+      virtual int getLength() { return int(sizeof(eit_event)+eventDescriptors.getLength()); }
    protected:
       virtual void Parse();
    private:
@@ -225,7 +225,7 @@
       int getServiceId() const;
       int getEventId() const;
       RunningStatus getRunningStatus() const;
-      virtual int getLength() { return sizeof(rst_info); }
+      virtual int getLength() { return int(sizeof(rst_info)); }
    protected:
       virtual void Parse();
    private:
@@ -242,7 +242,7 @@
    AIT() {}
    class Application : public LoopElement {
    public:
-      virtual int getLength() { return sizeof(ait_app)+applicationDescriptors.getLength(); }
+      virtual int getLength() { return int(sizeof(ait_app)+applicationDescriptors.getLength()); }
       long getOrganisationId() const;
       int getApplicationId() const;
       int getControlCode() const;
diff -ruN vdr-1.7.24/libsi/util.h vdr-1.7.25/libsi/util.h
--- vdr-1.7.24/libsi/util.h	2010-11-01 16:24:32.000000000 +0100
+++ vdr-1.7.25/libsi/util.h	2012-02-26 14:58:26.000000000 +0100
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: util.h 2.2 2010/11/01 15:24:32 kls Exp $
+ *   $Id: util.h 2.3 2012/02/26 13:58:26 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -54,10 +54,10 @@
    template <typename T> const T* getData(int offset) const { return (T*)(data_->data+offset+off); }
       //sets p to point to data+offset, increments offset
    template <typename T> void setPointerAndOffset(const T* &p, int &offset) const { p=(T*)getData(offset); offset+=sizeof(T); }
-   unsigned char operator[](const int index) const { return data_->data ? data_->data[off+index] : 0; }
+   unsigned char operator[](const int index) const { return data_->data ? data_->data[off+index] : (unsigned char)0; }
    int getLength() const { return data_->size; }
-   u_int16_t TwoBytes(const int index) const { return data_->data ? data_->TwoBytes(off+index) : 0; }
-   u_int32_t FourBytes(const int index) const { return data_->data ? data_->FourBytes(off+index) : 0; }
+   u_int16_t TwoBytes(const int index) const { return data_->data ? data_->TwoBytes(off+index) : u_int16_t(0); }
+   u_int32_t FourBytes(const int index) const { return data_->data ? data_->FourBytes(off+index) : u_int32_t(0); }
 
    bool isValid() const { return data_->valid; }
    bool checkSize(int offset) { return (data_->valid && (data_->valid=(offset>=0 && off+offset < data_->size))); }
@@ -73,9 +73,9 @@
       virtual void Delete() = 0;
 
       u_int16_t TwoBytes(const int index) const
-         { return (data[index] << 8) | data[index+1]; }
+         { return u_int16_t((data[index] << 8) | data[index+1]); }
       u_int32_t FourBytes(const int index) const
-         { return (data[index] << 24) | (data[index+1] << 16) | (data[index+2] << 8) | data[index+3]; }
+         { return u_int32_t((data[index] << 24) | (data[index+1] << 16) | (data[index+2] << 8) | data[index+3]); }
       /*#ifdef CHARARRAY_THREADSAFE
       void Lock();
       void Unlock();
@@ -140,7 +140,7 @@
 namespace DVBTime {
 time_t getTime(unsigned char date_hi, unsigned char date_lo, unsigned char timehr, unsigned char timemi, unsigned char timese);
 time_t getDuration(unsigned char timehr, unsigned char timemi, unsigned char timese);
-inline unsigned char bcdToDec(unsigned char b) { return ((b >> 4) & 0x0F) * 10 + (b & 0x0F); }
+inline unsigned char bcdToDec(unsigned char b) { return (unsigned char)(((b >> 4) & 0x0F) * 10 + (b & 0x0F)); }
 }
 
 //taken and adapted from libdtv, (c) Rolf Hakenes
diff -ruN vdr-1.7.24/menu.c vdr-1.7.25/menu.c
--- vdr-1.7.24/menu.c	2012-02-19 12:37:55.000000000 +0100
+++ vdr-1.7.25/menu.c	2012-03-02 11:33:17.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menu.c 2.37 2012/02/19 11:37:55 kls Exp $
+ * $Id: menu.c 2.39 2012/03/02 10:33:17 kls Exp $
  */
 
 #include "menu.h"
@@ -3093,7 +3093,6 @@
   SetSection(tr("Recording"));
   Add(new cMenuEditIntItem( tr("Setup.Recording$Margin at start (min)"),     &data.MarginStart));
   Add(new cMenuEditIntItem( tr("Setup.Recording$Margin at stop (min)"),      &data.MarginStop));
-  Add(new cMenuEditIntItem( tr("Setup.Recording$Primary limit"),             &data.PrimaryLimit, 0, MAXPRIORITY));
   Add(new cMenuEditIntItem( tr("Setup.Recording$Default priority"),          &data.DefaultPriority, 0, MAXPRIORITY));
   Add(new cMenuEditIntItem( tr("Setup.Recording$Default lifetime (d)"),      &data.DefaultLifetime, 0, MAXLIFETIME));
   Add(new cMenuEditStraItem(tr("Setup.Recording$Pause key handling"),        &data.PauseKeyHandling, 3, pauseKeyHandlingTexts));
@@ -3654,7 +3653,7 @@
            Channel = Direction > 0 ? Channels.Next(Channel) : Channels.Prev(Channel);
            if (!Channel && Setup.ChannelsWrap)
               Channel = Direction > 0 ? Channels.First() : Channels.Last();
-           if (Channel && !Channel->GroupSep() && cDevice::GetDevice(Channel, 0, true))
+           if (Channel && !Channel->GroupSep() && cDevice::GetDevice(Channel, LIVEPRIORITY, true, true))
               return Channel;
            }
      }
@@ -4294,7 +4293,7 @@
                }
            }
         }
-     else if (!Timer || (Timer->Priority() >= Setup.PrimaryLimit && !Timer->Pending())) {
+     else if (!Timer || !Timer->Pending()) {
         isyslog("no free DVB device to record channel %d!", ch);
         Skins.Message(mtError, tr("No free DVB device to record!"));
         }
diff -ruN vdr-1.7.24/menuitems.c vdr-1.7.25/menuitems.c
--- vdr-1.7.24/menuitems.c	2011-08-12 15:19:40.000000000 +0200
+++ vdr-1.7.25/menuitems.c	2012-03-02 16:49:57.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.c 2.10 2011/08/12 13:19:40 kls Exp $
+ * $Id: menuitems.c 2.11 2012/03/02 15:49:57 kls Exp $
  */
 
 #include "menuitems.h"
@@ -26,6 +26,7 @@
 cMenuEditItem::cMenuEditItem(const char *Name)
 {
   name = strdup(Name ? Name : "???");
+  SetHelp(NULL);
 }
 
 cMenuEditItem::~cMenuEditItem()
@@ -40,6 +41,27 @@
   cStatus::MsgOsdCurrentItem(buffer);
 }
 
+void cMenuEditItem::SetHelp(const char *Red, const char *Green, const char *Yellow, const char *Blue)
+{
+  // strings are NOT copied - must be constants!!!
+  helpRed    = Red;
+  helpGreen  = Green;
+  helpYellow = Yellow;
+  helpBlue   = Blue;
+  helpDisplayed = false;
+}
+
+bool cMenuEditItem::DisplayHelp(void)
+{
+  bool HasHelp = helpRed || helpGreen || helpYellow || helpBlue;
+  if (HasHelp && !helpDisplayed) {
+     cSkinDisplay::Current()->SetButtons(helpRed, helpGreen, helpYellow, helpBlue);
+     cStatus::MsgOsdHelpKeys(helpRed, helpGreen, helpYellow, helpBlue);
+     helpDisplayed = true;
+     }
+  return HasHelp;
+}
+
 // --- cMenuEditIntItem ------------------------------------------------------
 
 cMenuEditIntItem::cMenuEditIntItem(const char *Name, int *Value, int Min, int Max, const char *MinString, const char *MaxString)
@@ -382,9 +404,9 @@
 void cMenuEditStrItem::SetHelpKeys(void)
 {
   if (InEditMode())
-     cSkinDisplay::Current()->SetButtons(tr("Button$ABC/abc"), insert ? tr("Button$Overwrite") : tr("Button$Insert"), tr("Button$Delete"));
+     SetHelp(tr("Button$ABC/abc"), insert ? tr("Button$Overwrite") : tr("Button$Insert"), tr("Button$Delete"));
   else
-     cSkinDisplay::Current()->SetButtons(NULL);
+     SetHelp(NULL);
 }
 
 uint *cMenuEditStrItem::IsAllowed(uint c)
diff -ruN vdr-1.7.24/menuitems.h vdr-1.7.25/menuitems.h
--- vdr-1.7.24/menuitems.h	2011-06-13 15:46:03.000000000 +0200
+++ vdr-1.7.25/menuitems.h	2012-03-02 16:49:57.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: menuitems.h 2.5 2011/06/13 13:46:03 kls Exp $
+ * $Id: menuitems.h 2.6 2012/03/02 15:49:57 kls Exp $
  */
 
 #ifndef __MENUITEMS_H
@@ -19,10 +19,15 @@
 class cMenuEditItem : public cOsdItem {
 private:
   char *name;
+  const char *helpRed, *helpGreen, *helpYellow, *helpBlue;
+  bool helpDisplayed;
+protected:
+  void SetHelp(const char *Red, const char *Green = NULL, const char *Yellow = NULL, const char *Blue = NULL);
 public:
   cMenuEditItem(const char *Name);
   ~cMenuEditItem();
   void SetValue(const char *Value);
+  bool DisplayHelp(void);
   };
 
 class cMenuEditIntItem : public cMenuEditItem {
diff -ruN vdr-1.7.24/osd.c vdr-1.7.25/osd.c
--- vdr-1.7.24/osd.c	2011-08-15 11:27:39.000000000 +0200
+++ vdr-1.7.25/osd.c	2012-03-02 11:48:19.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: osd.c 2.23 2011/08/15 09:27:39 kls Exp $
+ * $Id: osd.c 2.25 2012/03/02 10:48:19 kls Exp $
  */
 
 #include "osd.h"
@@ -812,11 +812,11 @@
   // Fixed point scaling code based on www.inversereality.org/files/bitmapscaling.pdf
   // by deltener@mindtremors.com
   cBitmap *b = new cBitmap(int(round(Width() * FactorX)), int(round(Height() * FactorY)), Bpp(), X0(), Y0());
-  b->Replace(*this); // copy palette
   int RatioX = (Width() << 16) / b->Width();
   int RatioY = (Height() << 16) / b->Height();
   if (!AntiAlias || FactorX <= 1.0 && FactorY <= 1.0) {
      // Downscaling - no anti-aliasing:
+     b->Replace(*this); // copy palette
      tIndex *DestRow = b->bitmap;
      int SourceY = 0;
      for (int y = 0; y < b->Height(); y++) {
@@ -834,6 +834,7 @@
   else {
      // Upscaling - anti-aliasing:
      b->SetBpp(8);
+     b->Replace(*this); // copy palette (must be done *after* SetBpp()!)
      int SourceY = 0;
      for (int y = 0; y < b->Height() - 1; y++) {
          int SourceX = 0;
@@ -1007,7 +1008,7 @@
 void cPixmap::SetAlpha(int Alpha)
 {
   Lock();
-  Alpha = min(max(Alpha, ALPHA_TRANSPARENT), ALPHA_OPAQUE);
+  Alpha = constrain(Alpha, ALPHA_TRANSPARENT, ALPHA_OPAQUE);
   if (Alpha != alpha) {
      MarkViewPortDirty(viewPort);
      alpha = Alpha;
@@ -1647,8 +1648,8 @@
 {
   osdLeft = Left;
   osdTop = Top;
-  osdWidth = min(max(Width, MINOSDWIDTH), MAXOSDWIDTH);
-  osdHeight = min(max(Height, MINOSDHEIGHT), MAXOSDHEIGHT);
+  osdWidth = constrain(Width, MINOSDWIDTH, MAXOSDWIDTH);
+  osdHeight = constrain(Height, MINOSDHEIGHT, MAXOSDHEIGHT);
 }
 
 void cOsd::SetAntiAliasGranularity(uint FixedColors, uint BlendColors)
